var textToHTML = function (htmlText) {
  window.htmlTextObject = htmlText;
  textContent = htmlText.text;
  window.htmlTextObjectContent = textContent;

  htmlText.setText("");

  var xPos = htmlText.pos[0];
  var yPos = htmlText.pos[1];
  var xPosIframeOffsetinPercent =
    ((screen.width * (xPos / 1)) / screen.width) * 100;
  var yPosIframeOffsetinPercent =
    (-(screen.height * (yPos / 1)) / screen.height) * 100;
  textContentB64 = btoa(textContent);
  var canvasDOM = $("canvas").first();
  let src =
    "textTarget.html?xRes=" +
    screen.width +
    "&yRes=" +
    screen.height +
    "&text=" +
    textContentB64;

  var iframeoDiv =
    '<div id="iframe-container" style="  pointer-events: none; border-color: white;visibility: hidden; z-index: 0;text-align:center; width: 50%; position:relative; left: 0px; overflow-x: auto !important; -webkit-overflow-x-scrolling:touch !important; overflow-y: auto !important; -webkit-overflow-y-scrolling:touch !important;">';
  var iframeTag =
    '<iframe id="iframe" src="' +
    src +
    '" frameborder="0" style="width: 100%; overflow-x: auto !important; -webkit-overflow-x-scrolling:touch !important; overflow-y: auto !important; -webkit-overflow-y-scrolling:touch !important;display:block;"></iframe>';
  var closingTagIframeoDiv = "</div>";
  $("body").append(iframeoDiv + iframeTag + closingTagIframeoDiv);
  $("#iframe").on("load", function (iframe) {
    $(this)
      .contents()
      .find("html")
      .css({ display: "block", width: "100%", "overflow-x": "hidden" });
    absoluteHeightOfIframe = $(this).contents().find("html").height();
    relativeHeightofIframe =
      (absoluteHeightOfIframe / canvasDOM.height()) * 1.5;
    if (absoluteHeightOfIframe < canvasDOM.height())
      relativeHeightofIframe =
        (absoluteHeightOfIframe / canvasDOM.height()) * 100;
    relativeHeightofIframePerecent = relativeHeightofIframe + "%";
    console.log(
      "Absolut: " + absoluteHeightOfIframe + " CanvasDOM " + canvasDOM.height()
    );
    $("#iframe-container").css("visibility", "visible");
    $("#iframe-container").css("height", relativeHeightofIframePerecent);
    $("#iframe-container").css("top", yPosIframeOffsetinPercent + "%");
    $("#iframe-container").css("left", xPosIframeOffsetinPercent + "%");
    $(this).height("100%");
  });
};

var removeHTMLTextIframe = function (removeWindowVariable = true) {
  var el = document.getElementById("iframe-container");
  if (el != null) el.remove();
  if (removeWindowVariable) window.htmlTextObject = null;
};

var refreshHTMLText = function () {
  if (typeof window.htmlTextObject != "undefined") {
    if (window.htmlTextObject != null) {
      window.htmlTextObject.text = window.htmlTextObjectContent;
      console.log(window.htmlTextObject.text);
      textToHTML(window.htmlTextObject);
    }
  }
};

$(document).on("keydown", function (e) {
  if (e.key == "Escape") {
    removeHTMLTextIframe();
  }
});
$(window).resize(function () {
  if (typeof window.htmlTextObject != "undefined") {
    if (typeof continueRoutine != "undefined") {
      removeHTMLTextIframe(false);
      refreshHTMLText();
    }
  }
});

setInterval(function () {
  if (typeof window.htmlTextObject != "undefined") {
    if (typeof continueRoutine != "undefined") {
      if (!continueRoutine) {
        removeHTMLTextIframe();
      }
    }
  }
}, 1);
